	.module bind.c
	.area data(ram, con, rel)
_bind_mode::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./bind.c
	.dbsym e bind_mode _bind_mode c
	.area lit(rom, con, rel)
_pn_code_table::
	.byte 'j,231
	.byte 1,234
	.byte 3,253
	.byte 19,210
	.byte 220,192
	.byte 'k,184
	.byte 43,9
	.byte 187,178
	.byte 163,30
	.byte 242,164
	.byte 49,50
	.byte 'z,179
	.byte 'D,131
	.byte 59,221
	.byte 20,207
	.byte 142,201
	.byte 53,53
	.byte 'N,197
	.byte 243,'R
	.byte 'G,176
	.byte 124,35
	.byte 138,206
	.byte 'E,92
	.byte 'T,215
	.byte 129,172
	.byte 251,131
	.byte 'z,154
	.byte 'a,172
	.byte 60,18
	.byte 95,156
	.byte 57,152
	.byte 246,138
	.dbsym e pn_code_table _pn_code_table A[64:64]c
	.area text(rom, con, rel)
	.dbfile ./bind.c
	.dbfunc e get_next_channel _get_next_channel fV
_get_next_channel::
	.dbline -1
	.dbline 161
	.dbline 162
	mov A,[_sys_params+3]
	mov REG[0xe8],A
	mov REG[0xe9],6
	nop
	mov A,REG[0xeb]
	add A,6
	add [_sys_params],A
	.dbline 164
	mov A,77
	cmp A,[_sys_params]
	jnc L27
X0:
	.dbline 165
	.dbline 166
	sub [_sys_params],78
	.dbline 167
L27:
	.dbline -2
	.dbline 168
; //--------------------------------------------------------------------------
; //! \file
; //!
; //! Collection of the bind routines for automatic bind.
; //
; //--------------------------------------------------------------------------
; // $Archive: /WirelessUSB/LS/Firmware/LS DVK/PSoC/Radio/bind.c $
; // $Modtime: 3/19/04 1:34p $
; // $Revision: 1.5 $
; //--------------------------------------------------------------------------
; //
; // Copyright 2003-2004, Cypress Semiconductor Corporation.
; //
; // This software is owned by Cypress Semiconductor Corporation (Cypress)
; // and is protected by and subject to worldwide patent protection (United
; // States and foreign), United States copyright laws and international 
; // treaty provisions. Cypress hereby grants to licensee a personal, 
; // non-exclusive, non-transferable license to copy, use, modify, create 
; // derivative works of, and compile the Cypress Source Code and derivative 
; // works for the sole purpose of creating custom software in support of 
; // licensee product to be used only in conjunction with a Cypress integrated 
; // circuit as specified in the applicable agreement. Any reproduction, 
; // modification, translation, compilation, or representation of this 
; // software except as specified above is prohibited without the express 
; // written permission of Cypress.
; //
; // Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND,EXPRESS OR IMPLIED, 
; // WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
; // WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; // Cypress reserves the right to make changes without further notice to the
; // materials described herein. Cypress does not assume any liability arising
; // out of the application or use of any product or circuit described herein.
; // Cypress does not authorize its products for use as critical components in
; // life-support systems where a malfunction or failure may reasonably be
; // expected to result in significant injury to the user. The inclusion of
; // Cypress product in a life-support systems application implies that the
; // manufacturer assumes all risk of such use and in doing so indemnifies
; // Cypress against all charges.
; //
; // Use may be limited by and subject to the applicable Cypress software
; // license agreement.
; //
; //--------------------------------------------------------------------------
; 
; //--------------------------------------
; // Included files
; //--------------------------------------
; #include "bind.h"
; #include "protocol.h"
; #include "radio.h"
; 
; //--------------------------------------
; // Local Definitions and Types
; //--------------------------------------
; //! Receive packet
; extern LS_RX_PACKET  rx_packet;
; 
; //! Transmit packet
; extern LS_TX_PACKET  tx_packet;
; 
; //! Channel valid array for data packets
; extern UINT8         channel_valid[];
; 
; //! Length (bytes) of receive data.  Used in protocol_bind(), radio_receive(),  
; //! protocol_verify_packet(), protocol_send_packet(), and mfg_receive_test_packets() 
; extern UINT8         rx_data_length;
; 
; //! To tell whether the device is in a connected state or not
; UINT8  bind_mode = 0;
; 
; #ifdef DATA_RATE_16
; 
; //! 8 PN codes for a data rate of 32kbps or 64kbps, and 48 PN codes for a
; //! data rate of 16kbps
; const UINT8 pn_code_table[] = 
; {
;     0x83, 0xF7, 0xA8, 0x2D, 0x7A, 0x44, 0x64, 0xD3,
;     0x3F, 0x2C, 0x4E, 0xAA, 0x71, 0x48, 0x7A, 0xC9,
;     0x17, 0xFF, 0x9E, 0x21, 0x36, 0x90, 0xC7, 0x82,
;     0xA6, 0x46, 0xB5, 0x9A, 0x3A, 0x30, 0xB6, 0xAD,
;     0xBC, 0x5D, 0x9A, 0x5B, 0xEE, 0x7F, 0x42, 0xEB,
;     0x24, 0xF5, 0xDD, 0xF8, 0x7A, 0x77, 0x74, 0xE7,
;     0x3D, 0x70, 0x7C, 0x94, 0xDC, 0x84, 0xAD, 0x95,
;     0x1E, 0x6A, 0xF0, 0x37, 0x52, 0x7B, 0x11, 0xD4,
;     0x62, 0xF5, 0x2B, 0xAA, 0xFC, 0x33, 0xBF, 0xAF,
;     0x40, 0x56, 0x32, 0xD9, 0x0F, 0xD9, 0x5D, 0x97,
;     0x8E, 0x4A, 0xD0, 0xA9, 0xA7, 0xFF, 0x20, 0xCA,
;     0x38, 0xB3, 0x31, 0xAB, 0x24, 0x78, 0xA6, 0xBD,
;     0x4C, 0x97, 0x9D, 0xBF, 0xB8, 0x3D, 0xB5, 0xBE,
;     0x0C, 0x5D, 0x24, 0x30, 0x9F, 0xCA, 0x6D, 0xBD,
;     0x29, 0x29, 0x7B, 0xB5, 0xC8, 0xF4, 0x4D, 0x8A,
;     0x50, 0x14, 0x33, 0xDE, 0xF1, 0x78, 0x95, 0xAD,
;     0xD6, 0xA6, 0xAA, 0x10, 0x96, 0xB3, 0xA6, 0xA7,
;     0xF6, 0xCE, 0x0D, 0x12, 0xE3, 0x66, 0xA6, 0x94,
;     0x0C, 0x3C, 0xFA, 0xF9, 0xF0, 0xF2, 0x10, 0xC9,
;     0xF4, 0xDA, 0x06, 0xDB, 0xBF, 0x4E, 0x6F, 0xB3,
;     0x93, 0x9C, 0x4E, 0x14, 0x1A, 0x39, 0xCF, 0xE6,
;     0xC9, 0x2C, 0x06, 0x93, 0x86, 0xB9, 0x9E, 0xD7,
;     0x9E, 0x08, 0xD1, 0xAE, 0x59, 0x5E, 0xE8, 0xF0,
;     0xC0, 0x90, 0x8F, 0xBB, 0x7C, 0x8E, 0x2B, 0x8E,
;     0x80, 0x69, 0x26, 0x80, 0x08, 0xF8, 0x49, 0xE7,
;     0x7d, 0x2d, 0x49, 0x54, 0xd0, 0x80, 0x40, 0xC1,
;     0xB6, 0xF2, 0xE6, 0x1B, 0x80, 0x5A, 0x36, 0xB4,
;     0x42, 0xAE, 0x9C, 0x1C, 0xDA, 0x67, 0x05, 0xF6,
;     0x9B, 0x75, 0xF7, 0xE0, 0x14, 0x8D, 0xB5, 0x80,
;     0xBF, 0x54, 0x98, 0xB9, 0xB7, 0x30, 0x5A, 0x88,
;     0x35, 0xD1, 0xFC, 0x97, 0x23, 0xD4, 0xC9, 0x88,
;     0xE1, 0xD6, 0x31, 0x26, 0x5F, 0xBD, 0x40, 0x93,
;     0xDC, 0x68, 0x08, 0x99, 0x97, 0xAE, 0xAF, 0x8C,
;     0xC3, 0x0E, 0x01, 0x16, 0x0E, 0x32, 0x06, 0xBA,
;     0xE0, 0x83, 0x01, 0xFA, 0xAB, 0x3E, 0x8F, 0xAC,
;     0x5C, 0xD5, 0x9C, 0xB8, 0x46, 0x9C, 0x7D, 0x84,
;     0xF1, 0xC6, 0xFE, 0x5C, 0x9D, 0xA5, 0x4F, 0xB7,
;     0x58, 0xB5, 0xB3, 0xDD, 0x0E, 0x28, 0xF1, 0xB0,
;     0x9A, 0xD6, 0x95, 0xBA, 0xA4, 0xC5, 0x32, 0x9C,
;     0x5F, 0x30, 0x3B, 0x56, 0x96, 0x45, 0xF4, 0xA1,
;     0x03, 0xBC, 0x6E, 0x8A, 0xEF, 0xBD, 0xFE, 0xF8,
;     0x88, 0x17, 0x13, 0x3B, 0x2D, 0xBF, 0x06, 0xD6,
;     0xF1, 0x94, 0x30, 0x21, 0xA1, 0x1C, 0x88, 0xA9,
;     0xD0, 0xD2, 0x8E, 0xBC, 0x82, 0x2F, 0xE3, 0xB4,
;     0x8C, 0xFA, 0x47, 0x9B, 0x83, 0xA5, 0x66, 0xD0,
;     0x07, 0xBD, 0x9F, 0x26, 0xC8, 0x31, 0x0F, 0xB8,
;     0xD7, 0xA1, 0x54, 0xB1, 0x5E, 0x89, 0xAE, 0x86,
;     0xEF, 0x03, 0x95, 0x89, 0xB4, 0x71, 0x61, 0x9D,
;     0x40, 0xBA, 0x97, 0xD5, 0x86, 0x4F, 0xCC, 0xD1,
; };
; #endif
; 
; #ifndef DATA_RATE_16
; 
; //! 8 PN codes for a data rate of 32kbps or 64kbps, and 48 PN codes for a
; //! data rate of 16kbps
; const UINT8 pn_code_table[] = 
; {
;     0x6A, 0xE7, 0x01, 0xEA, 0x03, 0xFD, 0x13, 0xD2, 
;     0xDC, 0xC0, 0x6B, 0xB8, 0x2B, 0x09, 0xBB, 0xB2, 
;     0xA3, 0x1E, 0xF2, 0xA4, 0x31, 0x32, 0x7A, 0xB3, 
;     0x44, 0x83, 0x3B, 0xDD, 0x14, 0xCF, 0x8E, 0xC9, 
;     0x35, 0x35, 0x4E, 0xC5, 0xF3, 0x52, 0x47, 0xB0, 
;     0x7C, 0x23, 0x8A, 0xCE, 0x45, 0x5C, 0x54, 0xD7, 
;     0x81, 0xAC, 0xFB, 0x83, 0x7A, 0x9A, 0x61, 0xAC, 
;     0x3C, 0x12, 0x5F, 0x9C, 0x39, 0x98, 0xF6, 0x8A, 
; };
; #endif
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    get_next_channel
; //
; //!  Description: Performs the channel selection algorithm. Every sixth channel
; //!               will be used.
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; void get_next_channel(void)
; {
;     sys_params.network_id.channel += (6 * (sys_params.network_id.pin + 1));
; 
;     if((NUM_CHANNELS) - 1 < sys_params.network_id.channel)
;     {
;         sys_params.network_id.channel -= NUM_CHANNELS;    
;     }
; }
L25:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e init_channel _init_channel fV
_init_channel::
	.dbline -1
	.dbline 184
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    init_channel
; //
; //!  Description: Initialize the channel selection algorithm to the top channel
; //!               in the channel subset
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; void init_channel(void)
; {
	xjmp L31
L30:
	.dbline 186
	.dbline 187
	add [_sys_params],6
	.dbline 188
L31:
	.dbline 185
;     while (sys_params.network_id.channel < NUM_CHANNELS - 6) 
	cmp [_sys_params],72
	jc L30
X1:
	.dbline -2
	.dbline 189
;     {
;         sys_params.network_id.channel += 6;
;     }
; }
L29:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e protocol_bind_init _protocol_bind_init fV
_protocol_bind_init::
	.dbline -1
	.dbline 206
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_bind_init
; //
; //!  Description: Initializes the channel to the top channel, and the bind mode
; //!               to a disconnected state puts the radio in sleep mode (See
; //!               radio_sleep() ), if necessary
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     Void
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; void protocol_bind_init()    // Bind Auto
; {
	.dbline 207
;     init_channel();
	xcall _init_channel
	.dbline 209
; 
;     bind_mode = DISCONNECTED_STATE;
	mov [_bind_mode],1
	.dbline -2
	.dbline 214
; 
; #ifdef RADIO_SLEEP_ENABLED
;     radio_sleep();
; #endif
; }
L33:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e protocol_bind _protocol_bind fc
;     pa_setting -> X+4
;         status -> X+3
; channel_timeout -> X+2
; packet_received -> X+1
;     tx_timeout -> X+0
_protocol_bind::
	.dbline -1
	push X
	mov X,SP
	add SP,5
	.dbline 242
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_bind
; //
; //!  Description: Formats the bind packet, reads radio information, sets up
; //!               the radio and reads/sets the power level.  Then as it runs
; //!               through the channels it sends bind requests until an 
; //!               acknowledge is received (or the maximum amount of requests 
; //!               have been sent).  If all channels have been run through 
; //!               without an ack, then a bind timeout occurs which would result
; //!               to an unsuccessful bind and all bind parameters are 
; //!               reinitialized.  If a good ack packet is received, it then 
; //!               creates and sends an ack packet back 3 times to ensure
; //!               delivery.  Then the settings are saved in NVRAM and the power 
; //!               settings are restored.
; //!                                 
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     
; //!               - LS_STATUS_SUCCESS - successful bind
; //!               - LS_STATUS_FAILED - unsuccessful bind    
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; UINT8 protocol_bind()    // Bind Auto
; {
	.dbline 244
;     UINT8  channel_timeout;
;     UINT8  status = LS_STATUS_SUCCESS;
	mov [X+3],0
	.dbline 253
;     UINT8  packet_received;
;     UINT8  tx_timeout;
;     UINT8  pa_setting;
;         
; #ifdef RADIO_SLEEP_ENABLED
;     radio_wakeup();  
; #endif
;          
;     bind_mode = DISCONNECTED_STATE;
	mov [_bind_mode],1
	.dbline 256
;     
;     // format the bind packet
;     tx_packet.bind.hdr.type    = BIND_REQ; 
	and [_tx_packet],15
	.dbline 257
;     tx_packet.bind.hdr.dev_type = DEVICE_TYPE; 
	mov A,[_tx_packet]
	and A,-15
	or A,4
	mov [_tx_packet],A
	.dbline 258
;     tx_packet.bind.hdr.parity  = protocol_gen_parity(tx_packet.first.byte);
	mov A,[_tx_packet]
	push A
	xcall _protocol_gen_parity
	and A,1
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-2
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 280
;     
; #ifndef PROTOCOL_1_1
;     // read the radio ID
;     SPI_RADIO_PUT( REG_ANALOG_CTL, (AGC_RSSI_CTL | PACTL_EN | MID_READ_EN ));    
; 
;     // read the Radio ID registers
;     tx_packet.bind.mid_1 =  SPI_RADIO_GET( REG_MFG_ID_1 + RADIO_ID_1 );  
;     tx_packet.bind.mid_2 =  SPI_RADIO_GET( REG_MFG_ID_1 + RADIO_ID_2 );  
;     tx_packet.bind.mid_3 =  SPI_RADIO_GET( REG_MFG_ID_1 + RADIO_ID_3 );  
;     tx_packet.bind.mid_4 =  SPI_RADIO_GET( REG_MFG_ID_1 + RADIO_ID_4 ); 
; 
;     // disable the Radio ID registers
;     SPI_RADIO_PUT( REG_ANALOG_CTL, (AGC_RSSI_CTL | PACTL_EN ));
; 
;     tx_packet.bind.checksum = protocol_calc_ck_sum((UINT8 *)&tx_packet.bind, 
;                                                    BIND_REQ_LEN-1, BIND_SEED);
; 
;     sys_params.network_id.pin = 0;
; #endif // PROTOCOL_1_1
; 
;     // load the bind pn_code index
;     radio_set_pn_code(&pn_code_table[(8 * BIND_PN_CODE)]);
	mov A,>_pn_code_table
	push A
	mov A,<_pn_code_table
	push A
	xcall _radio_set_pn_code
	add SP,-3
	.dbline 283
;      
;     // Read PA setting
;     pa_setting = radio_get_power_level();    
	mov A,-1
	push A
	mov A,35
	push A
	xcall _spi_radio_access
	mov [X+4],A
	.dbline 286
;     
;     // load Bind PA
;     radio_set_power_level(BIND_POWER_LEVEL);
	mov A,4
	push A
	mov A,-93
	push A
	xcall _spi_radio_access
	add SP,-4
	.dbline 289
; 
;     // seed the channel algorithm with bind parameters 0,0
;     sys_params.network_id.channel = 0;
	mov [_sys_params],0
	.dbline 293
;        
;     // send a bind request and wait for response, if no response change
;     // the channel and try again
;     for( channel_timeout = 0; channel_timeout < BIND_TIMEOUT; ++channel_timeout)
	mov [X+2],0
	xjmp L38
L35:
	.dbline 294
;     {   
	.dbline 296
;         // setup mode
;         radio_set_channel(sys_params.network_id.channel);
	mov A,[_sys_params]
	push A
	xcall _radio_set_channel
	add SP,-1
	.dbline 299
;         
;         // loop until ACK radio_received or TX retries exhausted
;         for(tx_timeout = 0; tx_timeout <= BIND_MAX_TRANSMITS; ++tx_timeout)
	mov [X+0],0
	xjmp L42
L39:
	.dbline 300
;         {                           
	.dbline 301
;             radio_transmit(BIND_REQ_LEN, (UINT8 *)&tx_packet);
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	mov A,1
	push A
	xcall _radio_transmit
	.dbline 304
; 
;             // wait for Bind Response 
;             if (radio_receive(LS_RX_PACKET_LEN, (UINT8 *)&rx_packet, (UINT8 *)&channel_valid, BIND_ACK_TIMEOUT) > 0)
	mov A,0
	push A
	mov A,60
	push A
	mov A,>_channel_valid
	push A
	mov A,<_channel_valid
	push A
	mov A,>_rx_packet
	push A
	mov A,<_rx_packet
	push A
	mov A,6
	push A
	xcall _radio_receive
	add SP,-10
	mov [__r0],A
	mov A,0
	cmp A,[__r0]
	jnc L43
X2:
	.dbline 305
;             {
	.dbline 306
;                 packet_received = protocol_verify_packet();
	xcall _protocol_verify_packet
	mov [X+1],A
	.dbline 307
;             }
L43:
	.dbline 309
; 
;             if (packet_received == BIND_RESP) 
	cmp [X+1],0
	jnz L45
	.dbline 310
;             {
	.dbline 311
;                 break;                   
	xjmp L41
L45:
	.dbline 314
	.dbline 321
	mov A,0
	push A
	mov A,8
	push A
	xcall _timer_delay_msec
	add SP,-2
	.dbline 323
	.dbline 324
L40:
	.dbline 299
	inc [X+0]
L42:
	.dbline 299
	mov A,4
	cmp A,[X+0]
	jnc L39
X3:
L41:
	.dbline 327
;             }
;             else
;             {
;                 //  radio_off();
;                 #ifdef RADIO_SLEEP_ENABLED
;                 radio_sleep();
;                 TIMER_DELAY_MSEC(8);
;                 radio_wakeup();
;                 #else
;                 TIMER_DELAY_MSEC(8);
;                 #endif
;             }
;         }
;        
;         // check for Bind timeout
;         if(tx_timeout >= BIND_MAX_TRANSMITS)
	cmp [X+0],4
	jc L47
X4:
	.dbline 328
;         {
	.dbline 330
;             // Clear Watchdog and Sleep Timer
;             M8C_ClearWDTAndSleep;
	mov REG[0xe3],56
	.dbline 333
; 
;             //try the next channel in the subset of channels
;             get_next_channel();
	xcall _get_next_channel
	.dbline 334
;         }
	xjmp L48
L47:
	.dbline 335
;         else if( (packet_received == BIND_RESP) && (rx_data_length == BIND_RESP_LEN) ) 
	cmp [X+1],0
	jnz L49
	cmp [_rx_data_length],6
	jnz L49
	.dbline 336
;         {  
	.dbline 340
;             // Good Ack
;             
;              // send an ACK
;             tx_packet.first.byte = 0;
	mov [_tx_packet],0
	.dbline 341
;             tx_packet.ack.hdr.type   = ACK_PACKET;                    
	mov A,[_tx_packet]
	and A,15
	or A,80
	mov [_tx_packet],A
	.dbline 342
;             tx_packet.ack.hdr.flag   = GOOD_ACK;
	or [_tx_packet],8
	.dbline 343
;             tx_packet.ack.hdr.parity = protocol_gen_parity(
	mov A,[_tx_packet]
	push A
	xcall _protocol_gen_parity
	and A,1
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-2
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 354
;                                       (UINT8) tx_packet.first.byte);
;               
; #ifdef CHECKSUM_ALL_PACKETS
;             tx_packet.data.app_packet[0] = 
;             protocol_calc_ck_sum((UINT8 *)&tx_packet, 1, 
;                      rx_packet.bind.checksum_seed );
; #endif        
;     
;             // send the ACK to the bind response multiple times to
;             // ensure delivery
;             radio_transmit(ACK_LEN, (UINT8 *)&tx_packet);
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	mov A,1
	push A
	xcall _radio_transmit
	add SP,-4
	.dbline 356
;             
;             TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 357
;             TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 358
;             TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 359
;             TIMER_DELAY_50_USEC();          
	xcall _timer_delay_50_usec
	.dbline 360
;             radio_transmit(ACK_LEN, (UINT8 *)&tx_packet);
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	mov A,1
	push A
	xcall _radio_transmit
	.dbline 362
;             
;             TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 363
;             TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 364
;             TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 365
;             TIMER_DELAY_50_USEC();
	xcall _timer_delay_50_usec
	.dbline 366
;             radio_transmit(ACK_LEN, (UINT8 *)&tx_packet);
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	mov A,1
	push A
	xcall _radio_transmit
	add SP,-6
	.dbline 376
;                                     
; #ifndef PROTOCOL_1_1
;             // extract the bind parameters and store them        
;             sys_params.network_id.pin         = rx_packet.bind.hdr.pin;
;             sys_params.network_id.channel     = rx_packet.bind.channel;
;             sys_params.network_id.pn_code     = rx_packet.bind.pn_code;
;             sys_params.network_id.seed        = rx_packet.bind.checksum_seed;
; #else
;             // extract Bridge MID from BIND_RESP 
;             sys_params.bridge_mid.mid_1        = rx_packet.bind.mid_1;
	mov [_sys_params],[_rx_packet+1]
	.dbline 377
;             sys_params.bridge_mid.mid_2        = rx_packet.bind.mid_2;
	mov [_sys_params+1],[_rx_packet+2]
	.dbline 378
;             sys_params.bridge_mid.mid_3        = rx_packet.bind.mid_3;
	mov [_sys_params+2],[_rx_packet+3]
	.dbline 379
;             sys_params.bridge_mid.mid_4        = rx_packet.bind.mid_4;
	mov [_sys_params+3],[_rx_packet+4]
	.dbline 383
;             // store sys_params
; #endif // PROTOCOL_1_1
; 
;             status = LS_STATUS_SUCCESS;
	mov [X+3],0
	.dbline 384
;             break; // exit the for loop
	xjmp L37
L49:
L48:
	.dbline 386
L36:
	.dbline 293
	inc [X+2]
L38:
	.dbline 293
	cmp [X+2],-126
	jc L35
X5:
L37:
	.dbline 389
;         }
;     }  // for()
;     
;     // Restore PA setting
;     radio_set_power_level(pa_setting);
	mov A,[X+4]
	and A,7
	push A
	mov A,-93
	push A
	xcall _spi_radio_access
	add SP,-2
	.dbline 392
;     
;     // check the results of the while loop
;     if(channel_timeout > BIND_TIMEOUT - 1)
	mov A,-127
	cmp A,[X+2]
	jnc L58
X6:
	.dbline 393
;     {
	.dbline 395
;         // can't Bind, reset to original bind parameters
;         protocol_bind_init();
	xcall _protocol_bind_init
	.dbline 397
;         
;         status = LS_STATUS_FAILED;
	mov [X+3],1
	.dbline 398
;     }
	xjmp L59
L58:
	.dbline 399
;     else if(packet_received == BIND_RESP)   // ack sent OK
	cmp [X+1],0
	jnz L60
	.dbline 400
;     {
	.dbline 402
;         // store parameters in NVRAM
;         NVRAM_WRITE( &sys_params );
	mov A,>_sys_params
	push A
	mov A,<_sys_params
	push A
	mov A,-6
	push A
	xcall _flash_write_lite
	.dbline 406
;         
; #ifdef PROTOCOL_1_1
;         // calculate channel, PN code, etc. from the Bridge MID
;         calculate_network_id();
	xcall _calculate_network_id
	.dbline 410
; #endif // PROTOCOL_1_1
;      
;         // give the dongle time to ping before trying to reconnect
;         TIMER_DELAY_MSEC(BRIDGE_PING_TIME);
	mov A,0
	push A
	mov A,30
	push A
	xcall _timer_delay_msec
	add SP,-5
	.dbline 412
;         
;         init_channel();
	xcall _init_channel
	.dbline 414
;         
;         status = protocol_reconnect();
	xcall _protocol_reconnect
	mov [X+3],A
	.dbline 422
; 
; #ifdef ENCRYPT_DATA
;         if (status == LS_STATUS_SUCCESS) 
;         {
;             encrypt_request_key();
;         }
; #endif  // ENCRYPT_DATA
;     }
L60:
L59:
	.dbline 428
; 
; #ifdef RADIO_SLEEP_ENABLED
;     radio_sleep();  
; #endif
;         
;     return status;
	mov A,[X+3]
	.dbline -2
L34:
	add SP,-5
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l pa_setting 4 c
	.dbsym l status 3 c
	.dbsym l channel_timeout 2 c
	.dbsym l packet_received 1 c
	.dbsym l tx_timeout 0 c
	.dbend
	.dbfunc e protocol_reconnect _protocol_reconnect fc
;         status -> X+2
; packet_received -> X+1
;        timeout -> X+0
_protocol_reconnect::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 457
; }
; 
; 
; ///////////////////////////////////////////////////////////////////////////////
; //
; //  Function:    protocol_reconnect
; //
; //!  Description: Checks for an unbound device, resets radio (and restore
; //!               transmit valid bits if necessary), formats a connect data 
; //!               packet, reads radio information and sets up the radio.  It 
; //!               then reads and adjusts power level (if DYNAMIC_PA enabled).
; //!               Then as it runs through the channels it sends connect requests
; //!               until an good response is received (or the maximum amount of
; //!               requests have been sent). If all channels have been run through 
; //!               without a response, then it tries the original channel a few
; //!               times.  If no response is received on any channel the 
; //!               connection is unsuccessful.
; //!               
; //!
; //!  Inputs:      Void
; //!
; //!  Returns:     
; //!               - LS_STATUS_SUCCESS - successful connection
; //!               - LS_STATUS_FAILED - unsuccessful connection    
; //!
; ///////////////////////////////////////////////////////////////////////////////
; 
; UINT8 protocol_reconnect()
; {
	.dbline 467
;     UINT8  timeout;
;     UINT8  status;
;     UINT8  packet_received;
; #ifdef DYNAMIC_PA_SUPPORT
;     UINT8  pa_setting = PA_BIAS_MASK;
;     UINT8  channel_count = 0;
; #endif
;         
;     // check for unbound device
;     if (sys_params.network_id.pin == 0) 
	cmp [_sys_params+3],0
	jnz L63
	.dbline 468
;     {
	.dbline 474
;         // Turn off the radio
; #ifdef RADIO_SLEEP_ENABLED        
;         radio_sleep();
; #endif
; 
;         return LS_STATUS_FAILED;
	mov A,1
	xjmp L62
L63:
	.dbline 477
;     }
;     
;     bind_mode = DISCONNECTED_STATE;
	mov [_bind_mode],1
	.dbline 478
;     status = LS_STATUS_FAILED;
	mov [X+2],1
	.dbline 483
; 
;     // check for radio resetting due to a glitch on the N_RESET
;     // pin. The TX Valids bit should be 0xFF. If not that value the 
;     // radio is corrupted.
;     if( radio_get_power_level() == 0x00)
	mov A,-1
	push A
	mov A,35
	push A
	xcall _spi_radio_access
	add SP,-2
	cmp A,0
	jnz L66
	.dbline 484
;     {
	.dbline 486
;         // reset the radio
;         radio_init();       
	xcall _radio_init
	.dbline 487
;     }
L66:
	.dbline 492
;     
;     // select a channel, send a connect request, and
;     // wait for a connect response
;     // format the bind packet
;     tx_packet.connect.hdr.type   = CONNECT_REQ; 
	mov A,[_tx_packet]
	and A,15
	or A,16
	mov [_tx_packet],A
	.dbline 496
; #ifdef DYNAMIC_PA_SUPPORT
;     tx_packet.connect.hdr.pin    = protocol_device_type;
; #else
;     tx_packet.connect.hdr.pin    = sys_params.network_id.pin;
	mov A,[_sys_params+3]
	and A,7
	asl A
	and A,14
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-15
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 498
; #endif
;     tx_packet.connect.hdr.parity = 
	mov A,[_tx_packet]
	push A
	xcall _protocol_gen_parity
	and A,1
	mov [__r0],A
	mov A,[_tx_packet]
	and A,-2
	or A,[__r0]
	mov [_tx_packet],A
	.dbline 519
;         protocol_gen_parity((UINT8) tx_packet.first.byte);
; 
; #ifndef PROTOCOL_1_1
;     tx_packet.connect.channel  = sys_params.network_id.base_channel; 
;     tx_packet.connect.pn_code   = sys_params.network_id.pn_code; 
;     
;     // read the radio ID
;     SPI_RADIO_PUT( REG_ANALOG_CTL, (AGC_RSSI_CTL | PACTL_EN | MID_READ_EN ));    
; 
;     // read the radio IDs
;     tx_packet.connect.mid_1 =  SPI_RADIO_GET( REG_MFG_ID_1);  
;     tx_packet.connect.mid_2 =  SPI_RADIO_GET( REG_MFG_ID_2);  
;     tx_packet.connect.mid_3 =  SPI_RADIO_GET( REG_MFG_ID_3);  
;     tx_packet.connect.mid_4 =  SPI_RADIO_GET( REG_MFG_ID_4); 
; 
;     // disable the Radio ID registers
;     SPI_RADIO_PUT( REG_ANALOG_CTL, (AGC_RSSI_CTL | PACTL_EN ));
;     
; #else
;     // load Bridge MID from sys_params into the tx_packet...
;     NVRAM_READ( &tx_packet.connect.mid_1, 4 );
	mov A,4
	push A
	mov A,>_tx_packet+1
	push A
	mov A,<_tx_packet+1
	push A
	mov A,-6
	push A
	xcall _flash_read_lite
	add SP,-5
	.dbline 529
; #endif
; 
; #ifdef DYNAMIC_PA_SUPPORT
;     // Set PA field
;     //tx_packet.connect.pa = (SPI_RADIO_GET(REG_PA) & PA_BIAS_MASK);
;     tx_packet.connect.pa = radio_get_power_level();
; #endif
;        
;     // calculate checksum
;     tx_packet.connect.checksum =
	mov A,[_sys_params+2]
	push A
	mov A,5
	push A
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	xcall _protocol_calc_ck_sum
	mov [_tx_packet+5],A
	.dbline 535
;         protocol_calc_ck_sum( (UINT8 *)&tx_packet.connect, 
;                               CONNECT_REQ_LEN-1, sys_params.network_id.seed );
;     
;     // load the bind pnCode index
;     //radio_set_pn_code(sys_params.network_id.pn_code);
;     radio_set_pn_code(&pn_code_table[(8 * sys_params.network_id.pn_code)]);
	mov [__r1],[_sys_params+1]
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	add [__r1],<_pn_code_table
	adc [__r0],>_pn_code_table
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _radio_set_pn_code
	add SP,-6
	.dbline 539
;    
;     // send a bind request and wait for response, if no response change
;     // the channel and try again
;     for(timeout=0; timeout<CONNECT_TIMEOUT; timeout++)
	mov [X+0],0
	xjmp L76
L73:
	.dbline 540
;     {                
	.dbline 572
; #ifdef DYNAMIC_PA_SUPPORT
;         if (SUBSET_CHANNELS - 1 < channel_count)
;         {
;             // Clear Channel count
;             channel_count = 0;
; 
;             // Adjust PA (3,5, or 7)
;             if (pa_setting == 0x03)
;             {
;                 pa_setting = 0x07;
;             }
;             else
;             {
;                 pa_setting -= 0x02;
;             }
; 
;             // Change PA setting
;             radio_set_power_level(pa_setting);
; 
;             // Set PA field
;             tx_packet.connect.pa = pa_setting;
; 
;             // calculate check sum
;             tx_packet.connect.checksum =
;             protocol_calc_ck_sum( (UINT8 *)&tx_packet.connect, 
;                                       CONNECT_REQ_LEN-1, 
;                                       sys_params.network_id.seed );
;         }
; #endif    // DYNAMIC_PA_SUPPORT
;         
;         // setup radio_transmit mode
;         radio_set_channel(sys_params.network_id.channel);
	mov A,[_sys_params]
	push A
	xcall _radio_set_channel
	add SP,-1
	.dbline 573
;         radio_transmit(CONNECT_REQ_LEN, (UINT8 *)&tx_packet);
	mov A,>_tx_packet
	push A
	mov A,<_tx_packet
	push A
	mov A,6
	push A
	xcall _radio_transmit
	.dbline 576
; 
;         // wait for Connect Response 
;         if (radio_receive(LS_RX_PACKET_LEN, (UINT8 *)&rx_packet, 
	mov A,0
	push A
	mov A,60
	push A
	mov A,>_channel_valid
	push A
	mov A,<_channel_valid
	push A
	mov A,>_rx_packet
	push A
	mov A,<_rx_packet
	push A
	mov A,6
	push A
	xcall _radio_receive
	add SP,-10
	mov [__r0],A
	mov A,0
	cmp A,[__r0]
	jnc L77
X7:
	.dbline 578
;                           (UINT8 *)&channel_valid, CONNECT_ACK_TIMEOUT) > 0)
;         {
	.dbline 579
;             packet_received = protocol_verify_packet();
	xcall _protocol_verify_packet
	mov [X+1],A
	.dbline 580
;         }
L77:
	.dbline 582
;        
;         if(packet_received == CONNECT_RESP)
	cmp [X+1],2
	jnz L79
	.dbline 583
;         {
	.dbline 584
;             if ((rx_packet.connect.hdr.flag == GOOD_ACK ) &&
	mov A,[_rx_packet]
	asr A
	asr A
	asr A
	and A,1
	cmp A,1
	jnz L81
	cmp [_rx_data_length],1
	jnz L81
	.dbline 586
;                 (rx_data_length == CONNECT_RESP_LEN))
;             {
	.dbline 587
;                 bind_mode = CONNECTED_STATE;
	mov [_bind_mode],2
	.dbline 590
;               
;                 // return a success status...
;                 status = LS_STATUS_SUCCESS;
	mov [X+2],0
	.dbline 592
;                 
;                 break; // good response, exit the loop
	xjmp L75
L81:
	.dbline 595
;             } 
;             else
;             {
	.dbline 597
;                 // bad response, bump channel
;                 get_next_channel();         
	xcall _get_next_channel
	.dbline 598
;             }                    
	.dbline 599
;         }
	xjmp L80
L79:
	.dbline 601
;         else
;         {
	.dbline 607
; #ifdef APP_CALLBACK_FUNC
;             APP_CALLBACK_FUNC();
; #endif
; 
;             // Try a few times on the original channel
;             if (timeout > ORIGINAL_CHAN_RECONNECT_COUNT)
	mov A,5
	cmp A,[X+0]
	jnc L83
X8:
	.dbline 608
;             {
	.dbline 610
;                 // timeout, bump channel
;                 get_next_channel();
	xcall _get_next_channel
	.dbline 615
;                 
; #ifdef DYNAMIC_PA_SUPPORT
;                 ++channel_count;
; #endif
;             }
L83:
	.dbline 616
;         }
L80:
	.dbline 617
L74:
	.dbline 539
	inc [X+0]
L76:
	.dbline 539
	cmp [X+0],-9
	jc L73
X9:
L75:
	.dbline 624
;     }  // end for(timeout = 0; timeout < CONNECT_TIMEOUT; timeout++)
; 
;         
; #ifdef RADIO_SLEEP_ENABLED
;     radio_sleep();
; #endif
;     
;     return status;
	mov A,[X+2]
	.dbline -2
L62:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l status 2 c
	.dbsym l packet_received 1 c
	.dbsym l timeout 0 c
	.dbend
